<template>
<div>
	<i class="material-icons colors-plate">color_lens</i>
	<div class="board-color-picker">
		<div class="color-option" :class="{ selected: colors.blue.isSelected }" :style="{ backgroundColor: colors.blue.hex }" @click="pickColor(colors.blue)"></div>
		<div class="color-option" :class="{ selected: colors.red.isSelected }" :style="{ backgroundColor: colors.red.hex }" @click="pickColor(colors.red)"></div>
		<div class="color-option" :class="{ selected: colors.green.isSelected }" :style="{ backgroundColor: colors.green.hex }" @click="pickColor(colors.green)"></div>
		<div class="color-option" :class="{ selected: colors.orange.isSelected }" :style="{ backgroundColor: colors.orange.hex }" @click="pickColor(colors.orange)"></div>
		<div class="color-option" :class="{ selected: colors.yellow.isSelected }" :style="{ backgroundColor: colors.yellow.hex }" @click="pickColor(colors.yellow)"></div>
		<div class="color-option eraser" :class="{ selected: colors.white.isSelected }" :style="{ backgroundColor: colors.white.hex }" @click="pickColor(colors.white)"><i class="material-icons eraser">panorama_fish_eye</i></div>
	</div>
</div>
</template>

<script>

export default {
	data () {
		return {
			colors: {
				blue: { hex: '#2196f3', isSelected: true },
				red: { hex: '#f44336', isSelected: false },
				green: { hex: '#4caf50', isSelected: false },
				orange: { hex: '#ff9800', isSelected: false },
				yellow: { hex: '#ffeb3b', isSelected: false },
				white: { hex: '#ffffff', isSelected: false }
			}
		}
	},

	methods: {
		pickColor (color) {
			this.resetSelection()
			color.isSelected = true
			this.$emit('pickColor', color.hex)
		},
		resetSelection () {
			// TODO: iterate this.colors keys instead of setting each color separately
			this.colors.blue.isSelected = false
			this.colors.red.isSelected = false
			this.colors.green.isSelected = false
			this.colors.orange.isSelected = false
			this.colors.yellow.isSelected = false
			this.colors.white.isSelected = false
		}
	}
}
</script>

<style scoped>

.material-icons.colors-plate {
	position: absolute;
    top: 56px;
    font-size: 30px;
    right: -64px;
	color: #858585;
}

.material-icons.eraser {
    margin-top: 10px;
    font-size: 17px;
    color: #a7a7a7;
}

.board-color-picker {
	position: absolute;
    top: 100px;
    right: -70px;
}

.color-option {
	opacity: 0.4;
	cursor: pointer;
	height: 40px;
	width: 40px;
}

.color-option.selected {
	opacity: 1;
}

.color-option.eraser {
	height: 38px;
	width: 38px;
	margin-top: 40px;
	border: 1px solid #a7a7a7;

}

</style>
